<template>
  <q-dialog ref="dialogRef" @hide="onDialogHide">
    <q-card
      class="q-dialog-plugin text-center"
      style="width: 400px; max-width: 100%; padding: 25px 50px"
      flat
    >
      <q-card-section>
        <p><strong>Attempting to reconnect existing session</strong></p>
        <p>
          <small
            >You may have to open your wallet for connection to
            re-establish.</small
          >
        </p>
      </q-card-section>
      <q-card-section>
        <q-spinner class="q-ma-md" size="5em" />
      </q-card-section>
      <q-card-actions align="around">
        <q-btn color="primary" @click="onNewSessionClicked">New Session</q-btn>
      </q-card-actions>
    </q-card>
  </q-dialog>
</template>

<script lang="ts" setup>
import { useDialogPluginComponent } from 'quasar';

const props = defineProps({
  // ...your custom props
});

defineEmits([
  // REQUIRED; need to specify some events that your
  // component will emit through useDialogPluginComponent()
  ...useDialogPluginComponent.emits,
]);

const { dialogRef, onDialogHide, onDialogOK, onDialogCancel } =
  useDialogPluginComponent();
// dialogRef      - Vue ref to be applied to QDialog
// onDialogHide   - Function to be used as handler for @hide on QDialog
// onDialogOK     - Function to call to settle dialog with "ok" outcome
//                    example: onDialogOK() - no payload
//                    example: onDialogOK({ /*...*/ }) - with payload
// onDialogCancel - Function to call to settle dialog with "cancel" outcome

function onNewSessionClicked() {
  onDialogOK({ action: 'NEW_SESSION' });
}
</script>
